//=============================================================================
// AdvancedMutator.
//
// Author: Francesco Biscazzo
// Date: 2016
//=============================================================================
class AdvancedMutator extends Mutator;

var() bool bAutoRegister; // Register this mutator as next mutator of the GameInfo.BaseMutator.

function PostBeginPlay() {
	super.PostBeginPlay();
	
	if (bAutoRegister) {
		Level.Game.BaseMutator.NextMutator = self;
	}
}

function ModifyPlayer(Pawn Other)
{
	local AM_Pickup AMP;

	if ( Other.IsA('PlayerPawn') ) {
		if( Other.IsA('Spectator') || Other.FindInventoryType(class'AM_Pickup') != None )
			return;
		
		AMP = Spawn(class'AM_Pickup', Other);
		if (AMP != none) {
			AMP.bHeldItem = true;
			AMP.GiveTo( Other );
			Other.SelectedItem = AMP;
			AMP.PickupFunction(Other);
			
			AMP.RegisterAdvancedMutator(self);
		}
	}
	
	super.ModifyPlayer(Other);
}

function AM_Pickup getPawnAMP(Pawn pawn) {
	local AM_Pickup AMP;
	
	foreach AllActors(class'AM_Pickup', AMP) {
		if (AMP.Owner == pawn)
			return AMP;
	}
	
	return none;
}

function Fired(Pawn pawn, Weapon weapon, Actor HitActor) {
	//FIRETYPE CHECK BETA TEST
	local String fireType;
	
	fireType = String(weapon.getStateName());
	
	Level.Game.BroadcastMessage("[<Fired> | pawn:"@pawn$" | weapon:"@weapon$" | fireType:"@fireType$" | HitActor:"@HitActor$"]");
}

function Jumped(Pawn pawn) {
	Level.Game.BroadcastMessage("[<Jumped> | pawn:"@pawn$"]");
}

function ChangedWeapon(Pawn pawn, Weapon oldWeapon, Weapon newWeapon) {
	Level.Game.BroadcastMessage("[<ChangedWeapon> | pawn:"@pawn$" | oldWeapon:"@oldWeapon$" | newWeapon:"@newWeapon$"]");
}

function TouchedPickUp(Pawn pawn, Inventory item) {
	Level.Game.BroadcastMessage("[<PickedUp> | pawn:"@pawn$" | item:"@item$"]");
}

function ChangedZone(Pawn pawn, ZoneInfo newZone) {
	Level.Game.BroadcastMessage("[<ChangedZone> | pawn:"@pawn$" | newZone:"@newZone$"]");
}

function ChangedState(Pawn pawn, String stateName) {
	Level.Game.BroadcastMessage("[<ChangedState> | pawn:"@pawn$" | stateName:"@stateName$"]");
}

function ChangedWeaponState(Pawn pawn, Weapon weapon, String stateName) {
	Level.Game.BroadcastMessage("[<ChangedWeaponState> | pawn:"@pawn$" | weapon:"@weapon$" | stateName:"@stateName$"]");
}

function AimedActor(Pawn pawn, Weapon weapon, Actor aimedActor) {
	Level.Game.BroadcastMessage("[<AimedActor> | pawn:"@pawn$" | weapon:"@weapon$" | aimedActor:"@aimedActor$"]", false, 'DeathMessage');
}